(defun cinioci(x)
  (prog ()
     (setq j 2)
     (setq y '())
   loop
     (cond
       ((= 1 x) (return y))
       ((= 0 (rem x j)) (setq y (cons j y)) (setq x (deli x j)))
     )
     (setq j (1+ j))
     (go loop)
  )
)

(defun deli(x y)
   (cond
     ((= 0 (rem x y)) (deli (/ x y) y))
     (t x)
   )
)


(defun clan(x y)
  (cond
    ((null y) nil)
    ((equal (car y) x) t)
    (t (clan x (cdr y)))
  )
)


(defun izbaci (x y)
  (cond
    ((null y) nil)
    ((equal (car y) x) (cdr y))
    (t (cons (car y) (izbaci x (cdr y))))
  )
)

(defun skupi(L)
  (cond
    ((null L) nil)
    ((clan (car L) (cdr L)) (cons (car L) (skupi (cons (car L) (izbaci (car L) (cdr L))))))
    (t (cons (car L) (skupi (cdr L))))
  )
)
 


(defun transp(x)
     (setq n (length x))
     (prog (i y z xx)
          (setq i 0)               
     loop
          (setq z ())
          (setq xx x)
          (dotimes (j n)
               (setq z (append z (list (nth i (car xx)))))
               (setq xx (cdr xx))
          )
          (cond ((= i 0) (setq y (list z)))
                (t (setq y (append y (list z)))))
          (setq i (1+ i))
          (cond ((= i n) (return y)))
          (go loop)
     )
)

(defun posled(x)
  (cond
    ((null (cdr x)) (car x))
    (t (posled (cdr x)))
  )
)

(defun izbpos (x)
  (cond
    ((null (cdr x)) nil)
    (t (cons (car x) (izbpos (cdr x))))
  )
)

(defmacro shiftright(x)
  `(cons (posled ,x) (izbpos ,x)))
