(defun petlja(N)
   (cond
      ((= N 0) N)
      (t (petlja (1- N))(print N))
   )
)


(defun vekMnoz (R RV)
   (cond
      ((null RV) nil)
      (t (cons (list (caar RV) (* R (cadar RV))) (vekMnoz R (cdr RV))))
   )
)


(defun fold (fun init L)
   (cond
      ((null L) init)
      (t (fun (car L) (fold fun init (cdr L))))
   )
)

(defun proizvod(L)
   (fold * 1 L)
)


(defmacro palindrom(L)
   `(jednaki ,L (obrni ,L))
)
 
(defun obrni(L)
   (cond
      ((null L) nil)
      (t (append (obrni (cdr L)) (list (car L))))
   )
)

(defun jednaki(A B)
   (cond
      ((null A) T)
      ((equal (car A) (car B)) (jednaki (cdr A) (cdr B)))
      (t nil)
   )
)
