(defun skalar (v1 v2)
  (cond
    ((null v1) nil)
    (t (append (list (* (car v1) (car v2))) (skalar (cdr v1) (cdr v2))))
  )
)

(defun mlist (n)
  (prog (x)
    (setq x nil)
    (dotimes (i n)
      (setq x (append x (list n))))
    (return x)
  )
)

(defun duplikati(l)
  (cond
    ((null l) nil)
    (t (cons (mlist (car l)) (duplikati (cdr l))))
  )
)

(defun kosinus (x r)
  (prog (s a i)
     (setq s 1)
     (setq a 1)
     (setq i 0)
   loop
     (print a)
     (cond
       ((< (abs a) r) (return s)))
     (setq a (* a (/ (* x (- x)) (* (+ (* 2.0 i) 1) (+ (* 2.0 i) 2.0)))))
     (setq s (+ s a))
     (setq i (1+ i))
     (go loop)
  )
)

(defmacro okret(l)
  `(cond
    ((atom ,l) ,l)
    (t (list (okret (caddr ,l)) '* (okret (car ,l))))
  )
)
