(defun sredi(x)
	(cond
		((null x) nil)
		((null (cdr x)) (cdr x))
		((and (zerop (car x)) (zerop (cadr x))) (sredi (cdr x)))
		(t (append (list (car x)) (sredi (cdr x))))
	)
)


(defun fakt (n)
	(cond
        	((= n 0) 1)
        	(t (* n (fakt (1- n))))
        )
)
(defun binom(n k)
	(/ (fakt n) (* (fakt k) (fakt (- n k))))
)
(defun st(x n)
	(cond
		((= n 0) 1)
		(t (* x (st x (1- n))))
	)
)
(defun stepen(x n)
	(prog (y k)
		(setq y '())
		(setq k 0)
		(cond 
			((zerop n) (return 1))
		)
	loop
		(cond
			((> k n) (return y))
			(t (setq y (append y (list (* (binom n k) (st (car x) (- n k)) (st (cadr x) k))))))
		)
		(setq k (1+ k))
		(go loop)
	)
)

(defun prvihn(n l)
	(cond
		((null l) 0)
		((= n 0) 0)
		(t (+ (car l) (prvihn (1- n) (cdr l))))
	)
)
(defun ZbirDijag (M)
	(prog (i s x)
		(setq i 0)
		(setq s 0)
		(setq x M)
		(setq n (length M))
	loop
		(cond
			((< i n) (setq s (+ s (prvihn i (car x))))
				 (setq i (1+ i))
				 (setq x (cdr x))
				 (go loop))
			(t (return s))
		)
	)
)
	
(defmacro jednacina (a b)
	`(cond
		((and (zerop ,a) (zerop ,b)) (princ "Resenje su svi realni brojevi")(terpri))
		((zerop ,a) (princ "Jednacina je nemoguca")(terpri))
		(t (- (/ ,b (* 1.0 ,a))))
	)
)