(defun clans (x l)
     (cond
          ((null l) nil)
          ((atom (car l)) (cond 
                             ((equal x (car l)) t)
                             (t (clans x (cdr l)))
                          ))
          (t (cond 
                  ((clans x (car l)) t)
                  (t (clans x (cdr l)))
             ))
     )
)

(defun min (x)
     (cond 
         ((null (cdr x)) (car x))
         ((< (car x) (setq m (min (cdr x)))) (car x))
         (t m)
     )
)

(defun izbaci (m x)
    (cond
         ((equal m (car x)) (cdr x))
         (t (cons (car x) (izbaci m (cdr x))))
    )
)

(defun sort (x)
    (cond
         ((null x) nil)
         (t (setq m (min x)) (cons m (sort (izbaci m x))))
    )
)

(defun filter (l fun)
    (cond
        ((null l) nil)
        ((apply fun (list (car l))) (cons (car l) (filter (cdr l) fun)))
        (t (filter (cdr l) fun))
    )
)

(defmacro clanp (e l)
  `(cond
       ((null ,l) nil)
       ((equal ,e (car ,l)) ,l)
       (t (clanp ,e (cdr ,l)))
   )
)