(defun parovi(a x)
  (cond 
    ((null x) nil)
    (t (cons (list a (car x)) (parovi a (cdr x))))
  )
)
(defun dekart(x y)
  (cond
    ((null x) nil)
    ((null y) nil)
    (t (append (parovi (car x) y) (dekart (cdr x) y)))
  )
)


(defun stepen (x &rest z)
  (st1 x z))
(defun st (x n)
  (cond
    ((= n 0) 1)
    (t (* x (st x (- n 1))))
  )
)
(defun st1 (a l)
  (cond
    ((null l) a)
    (t (setq a (st a (car l))) (st1 a (cdr l)))
  )
)
    
(defun nulam (n)
     (prog (i j z x)
          (setq i 0)
     loop
          (setq z ())
          (dotimes (j n)
               (setq z (append z '(0))))
          (cond ((= i 0) (setq x (list z)))
                (t (setq x (append x (list z)))))
          (setq i (1+ i))
          (cond ((= i n) (return x)))
          (go loop)
     )
)
(defun mnozenje (x y)
     (setq n (length x))
     (setq z (nulam n))
     (prog (i j k pom)
          (setq i 0)
     prvi
          (dotimes (j n) 
               (setq pom 0)
               (dotimes (k n)
                   (setq pom (+ pom (* (nth k (nth i x)) (nth j (nth k y))))))
               (setf (nth i (nth j z)) pom)
          ) 
          (setq i (1+ i))
          (cond ((= i n) (return z))
                (t (go prvi)))
     )
)


(defmacro obakraja(x)
 `(cond 
    ((null x) nil)
    (t (list (car ,x) (poslednji ,x)))))

(defun poslednji(x)
  (cond
    ((null (cdr x)) (car x))
    (t (poslednji (cdr x)))
  )
)