(defun take (x y z)
   (cond
      ((>= y x) z)
      (t (take (take (1- x) y z) (take (1- y) z x) (take (1- z) y x)))
   )
)

(defun pi (n)
   (prog (i x)
      (setq x 0)
      (setq s 1)
      (dotimes (i n)
         (setq x (+ x (/ s (1+ (* 2.0 i)))))
         (setq s (- s))
      )
      (setq x (* 4.0 x))
      (return x)
   )
)

;(defun matPlus (m1 m2)
;   (prog (n x y z)
;      (setq x m1)
;      (setq y m2)
;      (setq z '())
;    loop
;      (setq xx (car x))
;      (setq yy (car y))
;      (cond
;         ((= (car xx) (car yy)) (setq z (append z (list (car xx) (saberi (cadr xx) (cadr yy)))))
;                                (setq x (cdr x)) (setq y (cdr y))

(defmacro brPojava(x l)
  `(cond
      ((null ,l) 0)
      ((equal ,x (car ,l)) (1+ (brPojava ,x (cdr ,l))))
      (t (brPojava ,x (cdr ,l)))
   )
)